﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace async_await
{
    class Program
    {
        static void Main(string[] args)
        {
            test();
            log("Main: 调用test _ after");
            Thread.Sleep(Timeout.Infinite);
        }

        static  async void test()
        {
            log("test: await 之前");
            await doo();
            log("test: await 之后");
        }

        static async Task doo()
        {
            log("doo: Task 结果： " + await Task.Run(()=>{
                Thread.Sleep(1000);
                log("sTask1");
                return 1;
            }));

            log("doo: Task 结果： " + await Task.Run(() =>
            {
                Thread.Sleep(1000);
                log("sTask2");
                return 2;
            }));

            log("doo: Task 结果： " + await Task.Run(() =>
            {
                Thread.Sleep(1000);
                log("sTask3");
                return 3;
            }));

            Thread.Sleep(1000);
            Console.WriteLine("doo中在Task外的Thread.Sleep执行完毕");

           // Console.ReadKey();
        }


        static void log(string msg) 
        {
            Console.WriteLine("{0}:{1}", Thread.CurrentThread.ManagedThreadId, msg);
        }
    }
}
